import sys

import logging
import logging.config
import os
import traceback


__author__ = "neyro"
__date__ = "$13-mar-2009 10:15:51$"

class LoggerTest:
    logger = None

    def initLogger(self, logConfigFile, chanel):
        if os.path.isfile(logConfigFile):
            try:
                print "ok"
                logging.config.fileConfig(logConfigFile)
                logger = logging.getLogger(chanel)
                return logger

            except:
                traceback.print_exc(file=sys.stdout)

    def printandlog(self, text, mode=logging.INFO):
        if self.logger == None:
            print text
        else:
            self.logger.log(mode, text)

    def generate1kbline(self, line=None):
        if line==None:
            line = ""

        missing = 1024 - len(line)

        if missing >0:
            for i in range(missing-1):
                line += "."

        return line

    def run(self):
        self.logger = self.initLogger('loggertest.ini', 'loggertest')
        lines = 1000
        for i in range(lines):
            line = "testline: " + str(i+1) + " of " + str(lines)+" "
            if len(line)<1024:
                line = self.generate1kbline(line)       #write a line of at least 1kb
            self.printandlog(line)

if __name__ == "__main__":
    lt = LoggerTest()
    lt.run()
